# -----------------------------------------------------------------------------
#   $RCSfile: ShoppingAsync.mak,v $
#  
#   See Copyright for the status of this software.
#  
#   The OpenSOAP Project
#   http://opensoap.jp/
# -----------------------------------------------------------------------------
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL_PROGRAM=install -c
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSMLDIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = ShoppingClientAsync

#
cgi_service_PROGRAMFILES = ShoppingService.cgi

servicerootdir=/var/tmp/Shopping
serviceconfdir=$(servicerootdir)/conf
servicedatadir=$(servicerootdir)/data
servicekeysdir=$(servicerootdir)/keys
service_CONFFILES = Shopping.conf
service_DATAFILES = ProductSpec.data ProductStock.data

#
stdio_service_PROGRAMFILES = ShoppingService
SSML_FILES = Shopping.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS) -lcrypto
#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE_CGI
CLIENT_CGI_CFLAGS=$(CFLAGS) -DCLIENT_CGI

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)

#
SOURCES = \
	ClAsyncCmn.c \
	ClCmn.c \
	ShClCmn.c \
	ShClProductList.c \
	ShClGetProductCount.c \
	ShClGetProductSpec.c \
	ShClGetStockQty.c \
	ShClPlaceOrderCmn.c \
	ShClPlaceOrderSync.c \
	ShClPlaceOrderAsync.c \
	ShClMainAsync.c \
	SvCmn.c \
	ShSvCmn.c \
	ShSvGetProductCount.c \
	ShSvGetProductSpec.c \
	ShSvGetStockQty.c \
	ShSvPlaceOrder.c \
	ShSvMain.c

OBJS=$(SOURCES:.c=.o) ShSvMain.cgi.o


all: $(PROGRAMS)


## Make Client Programs

ShoppingClientAsync: \
	ClCmn.o \
	ClAsyncCmn.o \
	ShClCmn.o \
	ShClProductList.o \
	ShClGetProductCount.o \
	ShClGetProductSpec.o \
	ShClGetStockQty.o \
	ShClPlaceOrderCmn.o \
	ShClPlaceOrderSync.o \
	ShClPlaceOrderAsync.o \
	ShClMainAsync.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

## Make Service Programs

ShoppingService: \
	SvCmn.o \
	ShSvCmn.o \
	ShSvGetProductCount.o \
	ShSvGetProductSpec.o \
	ShSvGetStockQty.o \
	ShSvPlaceOrder.o \
	ShSvMain.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

ShoppingService.cgi: \
	SvCmn.o \
	ShSvCmn.o \
	ShSvGetProductCount.o \
	ShSvGetProductSpec.o \
	ShSvGetStockQty.o \
	ShSvPlaceOrder.o \
	ShSvMain.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

ShSvMain.cgi.o: ShSvMain.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

## Install Programs and Data

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exist."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir); \
	done

#
client-install: console-client-install

#
service-datas-install: $(service_DATAFILES)
	@if test -d $(DESTDIR)$(servicedatadir); then \
		echo "$(DESTDIR)$(servicedatadir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(servicedatadir)."; \
		mkdir -p $(DESTDIR)$(servicedatadir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(servicedatadir)."; \
		$(INSTALL_PROGRAM) \
			-m 0666 \
			$$f $(DESTDIR)$(servicedatadir); \
	done

#
service-common-install: service-datas-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSMLDIR); then \
		echo "$(DESTDIR)$(SSMLDIR) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSMLDIR)."; \
		mkdir -p $(DESTDIR)$(SSMLDIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(SSMLDIR)."; \
		$(INSTALL_PROGRAM) \
			-m 0644 \
			$$f $(DESTDIR)$(SSMLDIR); \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exist."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: \
	service-common-install \
	stdio-service-programs-install \
	ssml-install

#
cgi-service-programs-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-service-install: service-common-install cgi-service-programs-install

service-install: cgi-service-install stdio-service-install

#
sample-install: client-install service-install

# 
install: service-install

#
clean: 
	rm -f $(OBJS) $(PROGRAMS)

## Test Service Programs for Success Cases

stest1:
	cat SampleMessages/GetProductCountReq.xml | ./ShoppingService.cgi
stest2:	    
	cat SampleMessages/GetProductSpecReq.xml | ./ShoppingService.cgi
stest3:	    
	cat SampleMessages/GetStockQtyReq.xml | ./ShoppingService.cgi
stest4:	    
	cat SampleMessages/PlaceOrderReq.xml | ./ShoppingService.cgi


## Test Service Programs for Fault Cases

stest5:
	cat SampleMessages/GetProductCountReqF1.xml | ./ShoppingService.cgi
stest6:
	cat SampleMessages/GetProductSpecReqF1.xml | ./ShoppingService.cgi
	cat SampleMessages/GetProductSpecReqF2.xml | ./ShoppingService.cgi
	cat SampleMessages/GetProductSpecReqF3.xml | ./ShoppingService.cgi
stest7:
	cat SampleMessages/GetStockQtyReqF1.xml | ./ShoppingService.cgi
	cat SampleMessages/GetStockQtyReqF2.xml | ./ShoppingService.cgi
	cat SampleMessages/GetStockQtyReqF3.xml | ./ShoppingService.cgi
stest8:
	cat SampleMessages/PlaceOrderReqF1.xml | ./ShoppingService.cgi
	cat SampleMessages/PlaceOrderReqF2.xml | ./ShoppingService.cgi
	cat SampleMessages/PlaceOrderReqF3.xml | ./ShoppingService.cgi
	cat SampleMessages/PlaceOrderReqF4.xml | ./ShoppingService.cgi
	cat SampleMessages/PlaceOrderReqF5.xml | ./ShoppingService.cgi


## Test Client-Service Hookups for Success Cases

ctest1:
	./ShoppingClientAsync -s http://localhost/cgi-bin/ShoppingService.cgi -c EUC-JP GetProductList
ctest2:
	./ShoppingClientAsync -s http://localhost/cgi-bin/ShoppingService.cgi -c EUC-JP GetStockQty NS01
ctest3:
	./ShoppingClientAsync -s http://localhost/cgi-bin/ShoppingService.cgi -c EUC-JP PlaceOrder NS01 1


## Test Client-Server-Service Hookups for Success Cases

cstest1:
	./ShoppingClientAsync -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetProductList
cstest2:
	./ShoppingClientAsync -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetStockQty NS01
cstest3:
	./ShoppingClientAsync -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP PlaceOrder NS01 1
cstest4:
	./ShoppingClientAsync -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP PlaceOrderAsync NS01 1 > tmp_msg
cstest5:
	cat tmp_msg | ./ShoppingClientAsync -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP ConfirmOrder
