/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ChannelSelector.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ChannelSelector_H
#define ChannelSelector_H

#include <string>
#include "Defines.h"
#include "ChannelDescriptor.h"

namespace OpenSOAP {

  //ChannelManagerƂ̂ƂɂDescriptor𓾂
  class ChannelSelector {

  public:
	OPENSOAP_VAR
    virtual ~ChannelSelector();
  
  protected:
	OPENSOAP_VAR
    ChannelSelector();
#if defined(WIN32)
    ChannelSelector(const int addr);
#else
    ChannelSelector(const std::string& addr);
#endif

  public:
	OPENSOAP_VAR
    virtual int open(ChannelDescriptor& chnlDesc, 
		     const int waitSecond = ChannelDescriptor::NO_WAIT);
	OPENSOAP_VAR
    virtual int close(ChannelDescriptor& chnlDesc);

  protected:
#if defined(WIN32)
	OPENSOAP_VAR
    void setSocketAddr(const int addr);
#else
    void setSocketAddr(const std::string& addr);
#endif

    //ChannelManagerƂ̒ʐMoHm
    int connectChannelManager();

    virtual std::string makeSendOpenMessage(const int waitSecond);
    virtual std::string makeSendCloseMessage();

    //ChannelManagerƂ̒ʐMoHw
#if defined(WIN32)
	int
#else
    std::string
#endif
    	socketAddr_;
    
  };

} // end of namespace OpenSOAP


#endif /* ChannelSelector_H */
