/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Logger.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef Logger_H
#define Logger_H

//#include <features.h>
#include <nl_types.h>
#include <string>
//#include <stdarg.h>
#include <syslog.h>

namespace OpenSOAP {

  //g:
  /**
    #include "Logger.h"
    -lOpenSOAPSrvLogger
  
    int main(void) {
      //for initialize.
      Logger::init(); //use default msgcat. 

      ...
      printLog(NULL, "invalid option -- %s", LOG_ERR, 0x00100003L, "exe");
      ...
      Logger::term();
    }
  **/
  // /etc/syslog.conf ɓK؂ȃGg[ǉAsyslogd XV邱ƁB

  class Logger {

  public:
    //init()Ăяo
    class InitOpt {
    public:
      InitOpt() 
	: openlogOption(-1)
	, openlogFacility(-1)
	, outputLevel(-1)
	, eachTimeLevelCheck(false)
	, noRefSrvConf(false)
	, procSig("")
      {}
      ~InitOpt() {}
      //bZ[WJ^OwB""w莞default
      std::string catalogName; 
      //""ȊOwopenlog()̑PɎw肷B(1)
      std::string openlogIdent; 
      //-1ȊOwopenlog()̑QɎw肷B(P)
      int openlogOption;       
      //-1ȊOwopenlog()̑RɎw肷B(P)
      int openlogFacility;     
      //so̓x𖾎IɎw肵ꍇɎw肷B(P)
      //levelCheckAtOncetruew肵ꍇ̂ݗLB
      int outputLevel;
      //ȏ́Aw̏ꍇServerConfigQƂB

      //so̓x̊mFprintLog()ɍsȂ
      //ꍇtruew肷B
      //falsȅꍇ init()Ɉx̂݁B
      bool eachTimeLevelCheck;
      //server confQƂȂ
      //truew肷ƁAeachTimeLevelCheckfalsew肵ƂɂȂB
      //Llw肵ĂȂꍇ́AftHglgpB
      bool noRefSrvConf;
      //vZX̐ݒw莞ɃvZX̎wB
      //SrvConfQƎ "/(procSig)/LOG/LEVEL=?"ƎgpB
      std::string procSig;

      //(P) syslog(3)Q
    };

  protected:
    Logger();
    virtual ~Logger();

  public:
    static int init(const InitOpt& opt);
    static int init(); //all default env.
    //close msgcatalogue
    static int term();
    
    //static void printLog(int level, int errCode, ...);
    //optionMsg  : ƎɒǉwB
    //             w肵e̓bZ[W̐擪ɏo͂B
    //             w̕KvꍇNULLw肷B
    //defaultMsg : bZ[WJ^OɃ}b`Ȃꍇgp镶
    //level      : syslog()̑PƂĎgpBsyslog(3)Q
    //             server configŎw肳LOGGING_LEVEL傫ꍇ
    //             o͂ȂB
    //             () serversconfigLOGGING_LEVEL=6(LOG_INFO)̏ꍇ
    //                  wl=LOG_INFOȉ͏o͂邪ALOG_DEBUG
    //                  o͂ȂB
    static void printLog(const char* const optionMsg, 
			 const std::string& defaultMsg, 
			 int level, int errCode, ...);
    //static void printLog(const char* const optionMsg, 
    //			 int level, int errCode, ...);

#if 1
    //not use.
    static void printLogRefInitLevel(const char* const optionMsg, 
				     const std::string& defaultMsg, 
				     int level, int errCode, ...);
#endif 
    //IɃbZ[Wo̓xw肵ꍇɌĂяoB
    //init()ĂяoɌĂяoƁB
    //static void setOutputLevel(int level) { outputLevel = level; }

    //sɒo̓xserver config擾ꍇ
    //falsew肵ĂяoB
    //default true;
    //static void setLevelCheckOnce(bool flg) { levelCheckOnce = flg; }
  private:

    //server config query string
    //static const std::string QUERY_LOGGING_LEVEL;
    //static const std::string QUERY_MAX_LEN;

    //bZ[WJ^OfBXNv^
    static nl_catd catd;
    //bZ[Wo̓x
    static int outputLevel;
    static int outputMaxLen;
    static bool eachTimeLevelCheck;
    //static bool levelCheckAtOnce;

    static std::string procSig;
    
    static char* getErrorMsg(int errCode, const std::string& defaultMsg);
    //static char* getErrorMsg(int errCode, const char* const defMsg = NULL);
    //static char* getErrorMsg(int errCode);
    static void queryAndSetOutputLevel(int& level);

  };

}//end of namespace OpenSOAP

#endif /* Logger_H */
