/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: MapUtil.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef MapUtil_H
#define MapUtil_H

#include <string>
#include <map>
#include <utility>

#include "Defines.h"

namespace OpenSOAP {

#if defined(WIN32)
  class MapUtil {
	private:
		std::map<std::string, std::string> dataMap;
	public:
		OPENSOAP_VAR
			void insert(std::string& fst, std::string& snd);
		OPENSOAP_VAR
			void insert(std::pair<std::string, std::string> insData);
		OPENSOAP_VAR
			std::string operator[](const std::string& key);
#else
  class MapUtil : public std::map<std::string, std::string> {
#endif
  public:
	OPENSOAP_VAR
    MapUtil(const std::string& itemDelimit, 
	    const std::string& keyValDelimit);
	OPENSOAP_VAR
    ~MapUtil();

	OPENSOAP_VAR
    void insertItem(const std::string& data);
	OPENSOAP_VAR
    bool exists(const std::string& key) const;
	OPENSOAP_VAR
    std::string toString() const;

	OPENSOAP_VAR
    void spy() const;

  private:
    void insertMap(const std::string& item);

    std::string itemDelimit_;
    std::string keyValDelimit_;
  };

} // end of namespace OpenSOAP

#endif /* MapUtil_H */
