/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: connection.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef CONNECTION_H
#define CONNECTION_H

#include "Defines.h"

OPENSOAP_VAR
extern
void
sendStdout(std::vector<std::string> soapMsg);

OPENSOAP_VAR
extern
void
recvStdin(std::vector<std::string>& soapMsg);

/* Wo͂ string NX𑗂 */
OPENSOAP_VAR
extern
void
sendStdout(const std::string& soapMsg);
//sendStdout(std::string soapMsg);

/* W͂ǂݎʂ string NXɓ */
OPENSOAP_VAR
extern
void
recvStdin(std::string& soapMsg);

OPENSOAP_VAR
extern
int
openFIFO(std::string fifoName, int flags);

OPENSOAP_VAR
extern
void
sendFIFO(int fd, std::vector<std::string> soapMsg);

OPENSOAP_VAR
extern
void
recvFIFO(int fd, std::vector<std::string>& soapMsg);


/* FIFO  string NX𑗂 */
OPENSOAP_VAR
extern
void
sendFIFO(int fd, std::string soapMsg);

/* FIFO ǂݎʂ string NXɓ */
OPENSOAP_VAR
extern
void
recvFIFO(int fd, std::string& soapMsg);

OPENSOAP_VAR
extern
int
openSocket(const std::string& hostname, unsigned int port);

OPENSOAP_VAR
extern
#if defined(WIN32)
int
#else
ssize_t
#endif
sendSocket(int fd, const std::string& msg);

OPENSOAP_VAR
extern
#if defined(WIN32)
int
#else
ssize_t
#endif
recvSocket(int fd, std::string& msg);

#endif /* CONNECTION_H */

